#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

#define ESC    0x001B
#define F1     0x3B00
#define F2     0x3C00
#define RETURN 0x000D
#define PIU    0x002B
#define MEN    0x002D
#define OK_C M_PI
#define CARATTERE_O  "O"
#define CARATTERE_P  "P"
#define CARATTERE_C  "C"
#define CARATTERE_M  "M"
#define N_STEP       512

typedef struct
{ int x;
  int y;
} PXY;

double min_x,max_x,min_y,max_y;
double az,max_az,step_az,old_az;
double r,rm,l,pr;
double point,rect_p;
int    xasp,yasp;
int    lc,hc;

PXY r0,r1,p,c,m;
PXY old_r0,old_r1,old_p,old_c,old_m;

char step;
int  del_time;
PXY poly0[N_STEP];
int  n_punti0;
PXY poly1[N_STEP];
int  n_punti1;

char set_gra(void);
void disegno(void);
void calcoli(void);
void init_dati(void);
void draw(void);
void clr_draw(void);
void polyline(int n,PXY *p_xy);
int anl_key(void);


int main(void)
{
   if (set_gra()) return(-1);

   init_dati();
   disegno();


   closegraph();

   return 0;
}

char set_gra(void)
{
	int gra_drv = DETECT;  // drive grafico
	int gra_res = 2;       // risoluzione
	int errorcode;

	if ((errorcode = registerbgidriver(EGAVGA_driver)) != 0)

	initgraph(&gra_drv,&gra_res,"");//"C:\\BC\\BGI");       /*avvia grafica */

	if (gra_drv < 0 || errorcode == 0)                               /*controlla se ok*/
	  {    cputs("\r\n- Non sono in grado di usare"
			  " la grafica di questo computer."); /*esce se non pu */
		  return 1;
	  }
	graphdefaults();
	return 0;
}


void disegno(void)
{
  int    txt_x = min_x + 10;
  int    txt_y = min_y + 10;
  int    i;

  max_az   = 2 * M_PI;
  step_az  = max_az / (double) N_STEP;
  max_az  -= step_az;

  n_punti0 = 0;
  n_punti1 = 0;

  for (i = 0;i < N_STEP;i++)
	 { az   = az + step_az;
	   if (az >= max_az) az = 0;
	   calcoli();

	   if (az > OK_C)
		  {
			poly0[n_punti0].x = c.x;
			poly0[n_punti0].y = c.y;
			n_punti0++;
		  }
	   else
		  { poly1[n_punti1].x = c.x;
			poly1[n_punti1].y = c.y;
			n_punti1++;
		  }

	   if (anl_key() == ESC) return;
	 }



  rectangle(min_x,min_y,max_x,max_y);

  setcolor(WHITE);
  outtextxy(txt_x,txt_y,"Esc= exit");
  outtextxy(txt_x,txt_y + 10,"F1 = step");
  outtextxy(txt_x,txt_y + 20,"F2 = auto ");
  outtextxy(txt_x,txt_y + 30,"+  = +time");
  outtextxy(txt_x,txt_y + 40,"-  = -time");


  settextjustify(1,1);
  while(1)
	 { az   = az + step_az;
	   if (az >= max_az) az = 0;

	   calcoli();
	   clr_draw();
	   draw();
	   delay(del_time);

	   if (anl_key() == ESC) return;

	 }

}

void calcoli(void)
{
   double az1;
   double r1_x,p_x;


   r1_x = (double) r0.x + r * sin(az); // coordinate per il vertice del raggio
   r1.x = (int) (.5 + r1_x);
   r1.y = (int) (.5 + (double) r0.y - r * cos(az));
   m.x  = r0.x + rm * sin(az);                      // coordinate per il simbolo "M"
   m.y  = r0.y - rm * cos(az);
   pr   = sqrt(l * l - pow(r * cos(az),2));         // proiezione biella su asse x
   p_x  = (double) r1_x - pr;
   p.x  = p_x;
   p.y  = r0.y;
   c.x  = p.x;
   if (az > OK_C)
	   c.y  = (int) (.5 + (double) r0.y - tan(M_PI_2 + az) * (r0.x - p_x));
   else
	   c.y  = (int) (.5 + (double) r0.y - tan(M_PI_2 + az + M_PI) * (r0.x - p_x));

}


void init_dati(void)
{

  min_x  = 0;
  min_y  = 0;
  max_x  = getmaxx();
  max_y  = getmaxy();
  point  = 3;
  rect_p = 50;
  r      = 100;              // raggio
  rm     = r + 10;           // raggio per simbolo "M"
  l      = max(r + 1,300);   // lunghezza biella
  pr     =   1;              // proiezione biella su asse x
  r0.x   = 500;
  r0.y   = max_y * .5;
  del_time = 25;
  getaspectratio(&xasp, &yasp);
  hc = textheight(CARATTERE_O);
  lc = textwidth(CARATTERE_O);


}


void draw(void)
{

   setcolor(WHITE);
   outtextxy(r0.x + lc,r0.y - hc,CARATTERE_O);
   outtextxy(p.x,p.y - point - hc,CARATTERE_P);
   outtextxy(m.x,m.y,CARATTERE_M);

   setlinestyle(DOTTED_LINE,1,1);
   line(0,r0.y,max_x,r0.y);
   line(r0.x,0,r0.x,max_y);

   setcolor(LIGHTRED);
   setlinestyle(SOLID_LINE,1,1);
   circle(r0.x,r0.y,r);            // disegno cerchio

   setlinestyle(DOTTED_LINE,1,1);
   line(r0.x,r0.y,r1.x,r1.y);      // disegno il raggio
   circle(r1.x,r1.y,point);

   setcolor(LIGHTBLUE);
   setlinestyle(SOLID_LINE,1,1);
   line(r1.x,r1.y,p.x,p.y);        // disegno la biella
   circle(p.x,p.y,point);
   rectangle(p.x - rect_p * 1.5,p.y - rect_p,p.x + rect_p,p.y + rect_p); // disegno il pistone

   polyline(n_punti1,poly1);
   polyline(n_punti0,poly0);

   setcolor(LIGHTGREEN);
   setlinestyle(DOTTED_LINE,1,1);
   line(r1.x,r1.y,c.x,c.y);
   line(p.x,p.y,c.x,c.y);
   circle(c.x,c.y,point);

   setcolor(WHITE);
   outtextxy(c.x - lc,c.y,CARATTERE_C);
   setlinestyle(SOLID_LINE,1,1);
   rectangle(min_x,min_y,max_x,max_y);

   old_r0 = r0;
   old_r1 = r1;
   old_p  = p;
   old_c  = c;
   old_az = az;
   old_m  = m;


}

void clr_draw(void)
{

   setcolor(BLACK);
   outtextxy(old_r0.x + lc,old_r0.y - hc,CARATTERE_O);
   outtextxy(old_p.x,old_p.y - point - hc,CARATTERE_P);
   outtextxy(old_m.x,old_m.y,CARATTERE_M);

   setlinestyle(DOTTED_LINE,1,1);
   line(old_r0.x,old_r0.y,old_r1.x,old_r1.y); // scancello il raggio
   circle(old_r1.x,old_r1.y,point);

   setlinestyle(SOLID_LINE,1,1);
   line(old_r1.x,old_r1.y,old_p.x,old_p.y);   // scancello la biella
   circle(old_p.x,old_p.y,point);
   rectangle(old_p.x - rect_p * 1.5,old_p.y - rect_p,old_p.x + rect_p,old_p.y + rect_p); // scancello il pistone

   setlinestyle(DOTTED_LINE,1,1);
   line(old_r1.x,old_r1.y,old_c.x,old_c.y);
   line(old_p.x,old_p.y,old_c.x,old_c.y);
   circle(old_c.x,old_c.y,point);
   outtextxy(old_c.x - lc,old_c.y,CARATTERE_C);


}

void polyline(int n,PXY *p_xy)
{
  n--;
  moveto(p_xy[n].x,p_xy[n].y);
  while((--n) >= 0)
	   { lineto(p_xy[n].x,p_xy[n].y);
	   }
}


int anl_key(void)
{
  int car = 0;

  if (step)
	{
	 do {
		if (kbhit())
		   { car = getch();
			if (car == 0) car = getch() << 8;
			if (car == F2) step = 0;
		   }
	    } while(car != F1 && step && car != ESC);
	}
  else
	{ if (kbhit())
		{ car = getch();
		  if (car == 0) car = getch() << 8;
		  if (car == F1) step = 1;
		  if (car == MEN) del_time = max(1,del_time - 10);
		  if (car == PIU) del_time = min(1000,del_time + 10);
		}
	}

 return (car);
}


